POJ 1077 Eight

2024-05-05 12:48
文章标签 poj 1077 eight

本文主要是介绍POJ 1077 Eight,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

链接:http://poj.org/problem?id=1077

题目:

Language:
Eight
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 23382 Accepted: 10325 Special Judge

Description

The 15-puzzle has been around for over 100 years; even if you don't know it by that name, you've seen it. It is constructed with 15 sliding tiles, each with a number from 1 to 15 on it, and all packed into a 4 by 4 frame with one tile missing. Let's call the missing tile 'x'; the object of the puzzle is to arrange the tiles so that they are ordered as: 
 1  2  3  4 5  6  7  8 9 10 11 12 13 14 15  x 

where the only legal operation is to exchange 'x' with one of the tiles with which it shares an edge. As an example, the following sequence of moves solves a slightly scrambled puzzle: 
 1  2  3  4    1  2  3  4    1  2  3  4    1  2  3  4 5  6  7  8    5  6  7  8    5  6  7  8    5  6  7  8 9  x 10 12    9 10  x 12    9 10 11 12    9 10 11 12 13 14 11 15   13 14 11 15   13 14  x 15   13 14 15  x r->           d->           r-> 

The letters in the previous row indicate which neighbor of the 'x' tile is swapped with the 'x' tile at each step; legal values are 'r','l','u' and 'd', for right, left, up, and down, respectively. 

Not all puzzles can be solved; in 1870, a man named Sam Loyd was famous for distributing an unsolvable version of the puzzle, and 
frustrating many people. In fact, all you have to do to make a regular puzzle into an unsolvable one is to swap two tiles (not counting the missing 'x' tile, of course). 

In this problem, you will write a program for solving the less well-known 8-puzzle, composed of tiles on a three by three 
arrangement. 

Input

You will receive a description of a configuration of the 8 puzzle. The description is just a list of the tiles in their initial positions, with the rows listed from top to bottom, and the tiles listed from left to right within a row, where the tiles are represented by numbers 1 to 8, plus 'x'. For example, this puzzle 
 1  2  3 x  4  6 7  5  8 

is described by this list: 
 1 2 3 x 4 6 7 5 8 

Output

You will print to standard output either the word ``unsolvable'', if the puzzle has no solution, or a string consisting entirely of the letters 'r', 'l', 'u' and 'd' that describes a series of moves that produce a solution. The string should include no spaces and start at the beginning of the line.

Sample Input

 2  3  4  1  5  x  7  6  8 

Sample Output

ullddrurdllurdruldr

解题思路:

这是一个经典的8数码问题,对于这个问题,我们可以用搜索的方法来解决。用bfs()来找一条最短的可行路。对于这个问题,我们有几点要注意一下:1.这个问题的状态是9个数字(我们把x看成0)的一个排列,每种排列都代表一种状态,用bfs()搜索,就是从当前的一个排列,转移到另一个可行的排列,我们可以用一个结构体来表示这种状态;2.说到bfs(),我们自然就会想到vis[]数组,标志当前的一个状态是否有访问过,防止重复访问,算是剪枝吧,对于这个问题,一个状态有9个数字,最直接的想法是开一个9维的数组,这样显然是不太可行的,会爆内存,要解决这个问题,我们可以用hash的方法,将9个数字表示的一个状态映射成一个数字,这样一共就只有9!种不同的状态了,对于这个hash,有一种比较经典的做法,康拓展开,大意是这样的,hash = a * 8!+ b * 7! + c * 6! + d * 5! + e * 4! + f * 3!+ g * 2! + h * 1! + i * 0!;其中a表示的是,从第一个数字开始往后,比第一个数字小的数的个数,b表示,从第二个数字开始往后,比第二个数字小的数的个数,依次类推;3.要记录当前的路径,我们可以开一个全局数组path,一个全局数组pre,分别记录,到当前状态hash值的路径,以及前一个状态的hash值;4.还有一点,最好用G++编译器提交,用C++会超时,估计是因为G++对stl有优化。


代码:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <queue>
#include <algorithm>
using namespace std;struct P
{int step;char c;int a[9];
};
P state, dest;
char dir[5] = "udlr";
bool vis[362888];
int  pre[362888];
char path[362888];
char ans[362888];
int dx[4] = {-1, 1,  0, 0};
int dy[4] = { 0, 0, -1, 1};
int f[10], step, h;bool fun(P a, P b)
{for(int i = 0; i < 9; i++){if(a.a[i] != b.a[i]) return false;}return true;
}int hash(P p)
{int ret = 0;for(int i = 0; i < 9; i++){int num = 0;for(int j = i + 1; j < 9; j++){if(p.a[j] < p.a[i]) num++;}ret += f[8-i] * num;}return ret;
}int bfs()
{memset(vis, false, sizeof(vis));queue<P> q;q.push(state);while(!q.empty()){P src = q.front(); q.pop();if(vis[hash(src)]) continue;vis[hash(src)] = true;int x, y, z, t;for(int i = 0; i < 9; i++){if(0 == src.a[i]){t = i;break;}}x = t / 3; y = t % 3;for(int i = 0; i < 4; i++){int tx = x + dx[i], ty = y + dy[i];if(tx >= 0 && tx <= 2 && ty >= 0 && ty <= 2){P p;for(int j = 0; j < 9; j++){p.a[j] = src.a[j];}z = tx * 3 + ty;swap(p.a[t], p.a[z]);if(vis[hash(p)]) continue;p.step = src.step + 1;pre[hash(p)] = hash(src);path[hash(p)] = dir[i];if(fun(p, dest)){step = p.step;h = hash(p);return 1;}q.push(p);}}}return 0;
}int main()
{for(int i = 0; i < 8; i++) dest.a[i] = i + 1;dest.a[8] = 0;f[0] = 1;for(int i = 1; i < 10; i++) f[i] = i * f[i-1];char c; int i = 0;while(c = getchar()){if(c >= '1' && c <= '8'){state.a[i++] = c - '0';}if('x' == c){state.a[i++] = 0;}if(9 == i) break;}state.step = 0;if(bfs()){for(int i = 0; i < step; i++){ans[i] = path[h];h = pre[h];}for(int i = step - 1; i >= 0; i--){printf("%c", ans[i]);}puts("");}else{puts("unsolvable");}return 0;
}


这篇关于POJ 1077 Eight的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/961756

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i